Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DIA/diaar5.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DIA/diaar5.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DIA/diaar5.F90	(revision 14852)
@@ -34,5 +34,4 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:  ) ::   thick0       ! ocean thickness (interior domain)
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sn0          ! initial salinity
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   hstr_adv, hstr_ldf
 
    LOGICAL  :: l_ar5
@@ -55,6 +54,5 @@
       !!----------------------------------------------------------------------
       !
-      ALLOCATE( thick0(jpi,jpj) , sn0(jpi,jpj,jpk) , &
-         &      hstr_adv(jpi,jpj,jpts,2), hstr_ldf(jpi,jpj,jpts,2), STAT=dia_ar5_alloc )
+      ALLOCATE( thick0(jpi,jpj) , sn0(jpi,jpj,jpk), STAT=dia_ar5_alloc )
       !
       CALL mpp_sum ( 'diaar5', dia_ar5_alloc )
@@ -306,5 +304,5 @@
    END SUBROUTINE dia_ar5
 
-   ! TEMP: [tiling] These changes not necessary if using XIOS (subdomain support, will not output haloes)
+
    SUBROUTINE dia_ar5_hst( ktra, cptr, puflx, pvflx )
       !!----------------------------------------------------------------------
@@ -320,41 +318,30 @@
       !
       INTEGER    ::  ji, jj, jk
-
-      IF( cptr /= 'adv' .AND. cptr /= 'ldf' ) RETURN
-      IF( ktra /= jp_tem .AND. ktra /= jp_sal ) RETURN
+      REAL(wp), DIMENSION(A2D(nn_hls))  :: z2d
+
+      z2d(:,:) = puflx(:,:,1)
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
+         z2d(ji,jj) = z2d(ji,jj) + puflx(ji,jj,jk)
+      END_3D
 
       IF( cptr == 'adv' ) THEN
-         DO_2D( 0, 0, 0, 0 )
-            hstr_adv(ji,jj,ktra,1) = puflx(ji,jj,1)
-            hstr_adv(ji,jj,ktra,2) = pvflx(ji,jj,1)
-         END_2D
-         DO_3D( 0, 0, 0, 0, 1, jpkm1 )
-            hstr_adv(ji,jj,ktra,1) = hstr_adv(ji,jj,ktra,1) + puflx(ji,jj,jk)
-            hstr_adv(ji,jj,ktra,2) = hstr_adv(ji,jj,ktra,2) + pvflx(ji,jj,jk)
-         END_3D
+         IF( ktra == jp_tem ) CALL iom_put( 'uadv_heattr' , rho0_rcp * z2d(:,:) )  ! advective heat transport in i-direction
+         IF( ktra == jp_sal ) CALL iom_put( 'uadv_salttr' , rho0     * z2d(:,:) )  ! advective salt transport in i-direction
       ELSE IF( cptr == 'ldf' ) THEN
-         DO_2D( 0, 0, 0, 0 )
-            hstr_ldf(ji,jj,ktra,1) = puflx(ji,jj,1)
-            hstr_ldf(ji,jj,ktra,2) = pvflx(ji,jj,1)
-         END_2D
-         DO_3D( 0, 0, 0, 0, 1, jpkm1 )
-            hstr_ldf(ji,jj,ktra,1) = hstr_ldf(ji,jj,ktra,1) + puflx(ji,jj,jk)
-            hstr_ldf(ji,jj,ktra,2) = hstr_ldf(ji,jj,ktra,2) + pvflx(ji,jj,jk)
-         END_3D
-      ENDIF
-
-      IF( ntile == 0 .OR. ntile == nijtile ) THEN
-         IF( cptr == 'adv' ) THEN
-            IF( ktra == jp_tem ) CALL iom_put( 'uadv_heattr' , rho0_rcp * hstr_adv(:,:,ktra,1) )  ! advective heat transport in i-direction
-            IF( ktra == jp_sal ) CALL iom_put( 'uadv_salttr' , rho0     * hstr_adv(:,:,ktra,1) )  ! advective salt transport in i-direction
-            IF( ktra == jp_tem ) CALL iom_put( 'vadv_heattr' , rho0_rcp * hstr_adv(:,:,ktra,2) )  ! advective heat transport in j-direction
-            IF( ktra == jp_sal ) CALL iom_put( 'vadv_salttr' , rho0     * hstr_adv(:,:,ktra,2) )  ! advective salt transport in j-direction
-         ENDIF
-         IF( cptr == 'ldf' ) THEN
-            IF( ktra == jp_tem ) CALL iom_put( 'udiff_heattr' , rho0_rcp * hstr_ldf(:,:,ktra,1) ) ! diffusive heat transport in i-direction
-            IF( ktra == jp_sal ) CALL iom_put( 'udiff_salttr' , rho0     * hstr_ldf(:,:,ktra,1) ) ! diffusive salt transport in i-direction
-            IF( ktra == jp_tem ) CALL iom_put( 'vdiff_heattr' , rho0_rcp * hstr_ldf(:,:,ktra,2) ) ! diffusive heat transport in j-direction
-            IF( ktra == jp_sal ) CALL iom_put( 'vdiff_salttr' , rho0     * hstr_ldf(:,:,ktra,2) ) ! diffusive salt transport in j-direction
-         ENDIF
+         IF( ktra == jp_tem ) CALL iom_put( 'udiff_heattr' , rho0_rcp * z2d(:,:) ) ! diffusive heat transport in i-direction
+         IF( ktra == jp_sal ) CALL iom_put( 'udiff_salttr' , rho0     * z2d(:,:) ) ! diffusive salt transport in i-direction
+      ENDIF
+      !
+      z2d(:,:) = pvflx(:,:,1)
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
+         z2d(ji,jj) = z2d(ji,jj) + pvflx(ji,jj,jk)
+      END_3D
+
+      IF( cptr == 'adv' ) THEN
+         IF( ktra == jp_tem ) CALL iom_put( 'vadv_heattr' , rho0_rcp * z2d(:,:) )  ! advective heat transport in j-direction
+         IF( ktra == jp_sal ) CALL iom_put( 'vadv_salttr' , rho0     * z2d(:,:) )  ! advective salt transport in j-direction
+      ELSE IF( cptr == 'ldf' ) THEN
+         IF( ktra == jp_tem ) CALL iom_put( 'vdiff_heattr' , rho0_rcp * z2d(:,:) ) ! diffusive heat transport in j-direction
+         IF( ktra == jp_sal ) CALL iom_put( 'vdiff_salttr' , rho0     * z2d(:,:) ) ! diffusive salt transport in j-direction
       ENDIF
 
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DIA/diaptr.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DIA/diaptr.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DIA/diaptr.F90	(revision 14852)
@@ -71,4 +71,5 @@
 CONTAINS
 
+   ! NOTE: [tiling] tiling sometimes changes the diagnostics very slightly, usually where there are few zonal points e.g. the northern Indian Ocean basin. The difference is usually very small, for one point in one diagnostic. Presumably this is because of the additional zonal integration step over tiles.
    SUBROUTINE dia_ptr( kt, Kmm, pvtr )
       !!----------------------------------------------------------------------
@@ -93,5 +94,5 @@
 
          ! Calculate diagnostics only when zonal integrals have finished
-         IF( ntile == 0 .OR. ntile == nijtile ) CALL dia_ptr_iom(kt, Kmm, pvtr)
+         IF( .NOT. l_istiled .OR. ntile == nijtile ) CALL dia_ptr_iom(kt, Kmm, pvtr)
       ENDIF
 
@@ -317,9 +318,7 @@
          !
          IF( iom_use( 'uocetr_vsum_cumul' ) ) THEN
-            IF( ln_tile ) CALL dom_tile( ntsi, ntsj, ntei, ntej, ktile = 0 )         ! Use full domain
             CALL iom_get_var(  'uocetr_vsum_op', z2d ) ! get uocetr_vsum_op from xml
             z2d(:,:) = ptr_ci_2d( z2d(:,:) )
             CALL iom_put( 'uocetr_vsum_cumul', z2d )
-            IF( ln_tile ) CALL dom_tile( ntsi, ntsj, ntei, ntej, ktile = nijtile )   ! Revert to tile domain
          ENDIF
          !
@@ -589,5 +588,5 @@
 
 #if ! defined key_mpi_off
-      IF( ntile == 0 .OR. ntile == nijtile ) THEN
+      IF( .NOT. l_istiled .OR. ntile == nijtile ) THEN
          ish1d(1) = jpj*nbasin
          ish2d(1) = jpj ; ish2d(2) = nbasin
@@ -627,5 +626,5 @@
 
 #if ! defined key_mpi_off
-      IF( ntile == 0 .OR. ntile == nijtile ) THEN
+      IF( .NOT. l_istiled .OR. ntile == nijtile ) THEN
          ish1d(1) = jpj*jpk*nbasin
          ish3d(1) = jpj ; ish3d(2) = jpk ; ish3d(3) = nbasin
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/dom_oce.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/dom_oce.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/dom_oce.F90	(revision 14852)
@@ -73,9 +73,10 @@
    INTEGER         ::   nn_ltile_i, nn_ltile_j
 
-   ! Domain tiling (all tiles)
+   ! Domain tiling
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   ntsi_a       !: start of internal part of tile domain
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   ntsj_a       !
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   ntei_a       !: end of internal part of tile domain
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   ntej_a       !
+   LOGICAL, PUBLIC                                  ::   l_istiled    ! whether tiling is currently active or not
 
    !                             !: domain MPP decomposition parameters
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domain.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domain.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domain.F90	(revision 14852)
@@ -125,7 +125,7 @@
       !           !==  Reference coordinate system  ==!
       !
-      CALL dom_glo                            ! global domain versus local domain
-      CALL dom_nam                            ! read namelist ( namrun, namdom )
-      CALL dom_tile( ntsi, ntsj, ntei, ntej ) ! Tile domain
+      CALL dom_glo                      ! global domain versus local domain
+      CALL dom_nam                      ! read namelist ( namrun, namdom )
+      CALL dom_tile_init                ! Tile domain
 
       !
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domqco.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domqco.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domqco.F90	(revision 14852)
@@ -123,4 +123,7 @@
       CALL dom_qco_r3c( ssh(:,:,Kmm), r3t(:,:,Kmm), r3u(:,:,Kmm), r3v(:,:,Kmm), r3f(:,:) )
 #endif
+      ! dom_qco_r3c defines over [nn_hls, nn_hls-1, nn_hls, nn_hls-1]
+      IF( nn_hls == 2 ) CALL lbc_lnk( 'dom_qco_zgr', r3u(:,:,Kbb), 'U', 1._wp, r3v(:,:,Kbb), 'V', 1._wp, &
+         &                                           r3u(:,:,Kmm), 'U', 1._wp, r3v(:,:,Kmm), 'V', 1._wp )
       !
    END SUBROUTINE dom_qco_zgr
@@ -146,5 +149,7 @@
       !
       !
-      pr3t(:,:) = pssh(:,:) * r1_ht_0(:,:)   !==  ratio at t-point  ==!
+      DO_2D_OVR( nn_hls, nn_hls, nn_hls, nn_hls )
+         pr3t(ji,jj) = pssh(ji,jj) * r1_ht_0(ji,jj)   !==  ratio at t-point  ==!
+      END_2D
       !
       !
@@ -154,21 +159,21 @@
 #if ! defined key_qcoTest_FluxForm
       !                                ! no 'key_qcoTest_FluxForm' : surface weighted ssh average
-         DO_2D( 0, 0, 0, 0 )
-            pr3u(ji,jj) = 0.5_wp * (  e1e2t(ji  ,jj) * pssh(ji  ,jj)  &
-               &                    + e1e2t(ji+1,jj) * pssh(ji+1,jj)  ) * r1_hu_0(ji,jj) * r1_e1e2u(ji,jj)
-            pr3v(ji,jj) = 0.5_wp * (  e1e2t(ji,jj  ) * pssh(ji,jj  )  &
-               &                    + e1e2t(ji,jj+1) * pssh(ji,jj+1)  ) * r1_hv_0(ji,jj) * r1_e1e2v(ji,jj)
-         END_2D
+      DO_2D_OVR( nn_hls, nn_hls-1, nn_hls, nn_hls-1 )
+         pr3u(ji,jj) = 0.5_wp * (  e1e2t(ji  ,jj) * pssh(ji  ,jj)  &
+            &                    + e1e2t(ji+1,jj) * pssh(ji+1,jj)  ) * r1_hu_0(ji,jj) * r1_e1e2u(ji,jj)
+         pr3v(ji,jj) = 0.5_wp * (  e1e2t(ji,jj  ) * pssh(ji,jj  )  &
+            &                    + e1e2t(ji,jj+1) * pssh(ji,jj+1)  ) * r1_hv_0(ji,jj) * r1_e1e2v(ji,jj)
+      END_2D
 !!st      ELSE                                         !- Flux Form   (simple averaging)
 #else
-         DO_2D( 0, 0, 0, 0 )
-            pr3u(ji,jj) = 0.5_wp * (  pssh(ji,jj) + pssh(ji+1,jj  )  ) * r1_hu_0(ji,jj)
-            pr3v(ji,jj) = 0.5_wp * (  pssh(ji,jj) + pssh(ji  ,jj+1)  ) * r1_hv_0(ji,jj)
-         END_2D
+      DO_2D_OVR( nn_hls, nn_hls-1, nn_hls, nn_hls-1 )
+         pr3u(ji,jj) = 0.5_wp * (  pssh(ji,jj) + pssh(ji+1,jj  )  ) * r1_hu_0(ji,jj)
+         pr3v(ji,jj) = 0.5_wp * (  pssh(ji,jj) + pssh(ji  ,jj+1)  ) * r1_hv_0(ji,jj)
+      END_2D
 !!st      ENDIF
 #endif         
       !
       IF( .NOT.PRESENT( pr3f ) ) THEN              !- lbc on ratio at u-, v-points only
-         CALL lbc_lnk( 'dom_qco_r3c', pr3u, 'U', 1._wp, pr3v, 'V', 1._wp )
+         IF (nn_hls==1) CALL lbc_lnk( 'dom_qco_r3c', pr3u, 'U', 1._wp, pr3v, 'V', 1._wp )
          !
          !
@@ -179,20 +184,29 @@
          !                                ! no 'key_qcoTest_FluxForm' : surface weighted ssh average
 
-            DO_2D( 0, 0, 0, 0 )                               ! start from 1 since lbc_lnk('F') doesn't update the 1st row/line
-               pr3f(ji,jj) = 0.25_wp * (  e1e2t(ji  ,jj  ) * pssh(ji  ,jj  )  &
-                  &                     + e1e2t(ji+1,jj  ) * pssh(ji+1,jj  )  &
-                  &                     + e1e2t(ji  ,jj+1) * pssh(ji  ,jj+1)  &
-                  &                     + e1e2t(ji+1,jj+1) * pssh(ji+1,jj+1)  ) * r1_hf_0(ji,jj) * r1_e1e2f(ji,jj)
-            END_2D
+      DO_2D_OVR( nn_hls, nn_hls-1, nn_hls, nn_hls-1 )                               ! start from 1 since lbc_lnk('F') doesn't update the 1st row/line
+         ! round brackets added to fix the order of floating point operations
+         ! needed to ensure halo 1 - halo 2 compatibility
+         pr3f(ji,jj) = 0.25_wp * ( ( e1e2t(ji  ,jj  ) * pssh(ji  ,jj  )   &
+            &                      + e1e2t(ji+1,jj  ) * pssh(ji+1,jj  )   &
+            &                      )                                      & ! bracket for halo 1 - halo 2 compatibility
+            &                     + ( e1e2t(ji  ,jj+1) * pssh(ji  ,jj+1)  &
+            &                       + e1e2t(ji+1,jj+1) * pssh(ji+1,jj+1)  &
+            &                       )                                     & ! bracket for halo 1 - halo 2 compatibility
+            &                    ) * r1_hf_0(ji,jj) * r1_e1e2f(ji,jj)
+      END_2D
 !!st         ELSE                                      !- Flux Form   (simple averaging)
 #else
-            DO_2D( 0, 0, 0, 0 )                               ! start from 1 since lbc_lnk('F') doesn't update the 1st row/line
-               pr3f(ji,jj) = 0.25_wp * (  pssh(ji,jj  ) + pssh(ji+1,jj  )  &
-                  &                     + pssh(ji,jj+1) + pssh(ji+1,jj+1)  ) * r1_hf_0(ji,jj)
-            END_2D
+      DO_2D_OVR( nn_hls, nn_hls-1, nn_hls, nn_hls-1 )
+         ! round brackets added to fix the order of floating point operations
+         ! needed to ensure halo 1 - halo 2 compatibility
+         pr3f(ji,jj) = 0.25_wp * ( ( pssh(ji,jj  ) + pssh(ji+1,jj  ) ) &
+            &                     + ( pssh(ji,jj+1) + pssh(ji+1,jj+1)  &
+            &                       )                                  & ! bracket for halo 1 - halo 2 compatibility
+            &                    ) * r1_hf_0(ji,jj)
+      END_2D
 !!st         ENDIF
 #endif
          !                                                 ! lbc on ratio at u-,v-,f-points
-         CALL lbc_lnk( 'dom_qco_r3c', pr3u, 'U', 1._wp, pr3v, 'V', 1._wp, pr3f, 'F', 1._wp )
+         IF (nn_hls==1) CALL lbc_lnk( 'dom_qco_r3c', pr3u, 'U', 1._wp, pr3v, 'V', 1._wp, pr3f, 'F', 1._wp )
          !
       ENDIF
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domtile.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domtile.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DOM/domtile.F90	(revision 14852)
@@ -13,4 +13,5 @@
    !
    USE prtctl         ! Print control (prt_ctl_info routine)
+   USE lib_mpp , ONLY : ctl_stop, ctl_warn
    USE in_out_manager ! I/O manager
 
@@ -18,5 +19,10 @@
    PRIVATE
 
-   PUBLIC dom_tile   ! called by step.F90
+   PUBLIC dom_tile         ! called by step.F90
+   PUBLIC dom_tile_start   ! called by various
+   PUBLIC dom_tile_stop    ! "      "
+   PUBLIC dom_tile_init    ! called by domain.F90
+
+   LOGICAL, ALLOCATABLE, DIMENSION(:) ::   l_tilefin    ! whether a tile is finished or not
 
    !!----------------------------------------------------------------------
@@ -27,86 +33,222 @@
 CONTAINS
 
-   SUBROUTINE dom_tile( ktsi, ktsj, ktei, ktej, ktile )
+   SUBROUTINE dom_tile_init
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE dom_tile_init  ***
+      !!
+      !! ** Purpose :   Initialise tile domain variables
+      !!
+      !! ** Action  : - ntsi, ntsj     : start of internal part of domain
+      !!              - ntei, ntej     : end of internal part of domain
+      !!              - ntile          : current tile number
+      !!              - nijtile        : total number of tiles
+      !!              - nthl, nthr     : modifier on DO loop macro bound offset (left, right)
+      !!              - nthb, ntht     :              "         "               (bottom, top)
+      !!              - l_istiled      : whether tiling is currently active or not
+      !!              - l_tilefin      : whether a tile is finished or not
+      !!----------------------------------------------------------------------
+      INTEGER ::   jt                                     ! dummy loop argument
+      INTEGER ::   iitile, ijtile                         ! Local integers
+      !!----------------------------------------------------------------------
+      IF( ln_tile .AND. nn_hls /= 2 ) CALL ctl_stop('dom_tile_init: Tiling is only supported for nn_hls = 2')
+
+      ntile = 0                     ! Initialise to full domain
+      nijtile = 1
+      ntsi = Nis0
+      ntsj = Njs0
+      ntei = Nie0
+      ntej = Nje0
+      nthl = 0
+      nthr = 0
+      nthb = 0
+      ntht = 0
+      l_istiled = .FALSE.
+
+      IF( ln_tile ) THEN            ! Calculate tile domain indices
+         iitile = Ni_0 / nn_ltile_i       ! Number of tiles
+         ijtile = Nj_0 / nn_ltile_j
+         IF( MOD( Ni_0, nn_ltile_i ) /= 0 ) iitile = iitile + 1
+         IF( MOD( Nj_0, nn_ltile_j ) /= 0 ) ijtile = ijtile + 1
+
+         nijtile = iitile * ijtile
+         ALLOCATE( ntsi_a(0:nijtile), ntsj_a(0:nijtile), ntei_a(0:nijtile), ntej_a(0:nijtile), l_tilefin(nijtile) )
+
+         l_tilefin(:) = .FALSE.
+
+         ntsi_a(0) = Nis0                 ! Full domain
+         ntsj_a(0) = Njs0
+         ntei_a(0) = Nie0
+         ntej_a(0) = Nje0
+
+         DO jt = 1, nijtile               ! Tile domains
+            ntsi_a(jt) = Nis0 + nn_ltile_i * MOD(jt - 1, iitile)
+            ntsj_a(jt) = Njs0 + nn_ltile_j * ((jt - 1) / iitile)
+            ntei_a(jt) = MIN(ntsi_a(jt) + nn_ltile_i - 1, Nie0)
+            ntej_a(jt) = MIN(ntsj_a(jt) + nn_ltile_j - 1, Nje0)
+         ENDDO
+      ENDIF
+
+      IF(lwp) THEN                  ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'dom_tile : Domain tiling decomposition'
+         WRITE(numout,*) '~~~~~~~~'
+         IF( ln_tile ) THEN
+            WRITE(numout,*) iitile, 'tiles in i'
+            WRITE(numout,*) '    Starting indices'
+            WRITE(numout,*) '        ', (ntsi_a(jt), jt=1, iitile)
+            WRITE(numout,*) '    Ending indices'
+            WRITE(numout,*) '        ', (ntei_a(jt), jt=1, iitile)
+            WRITE(numout,*) ijtile, 'tiles in j'
+            WRITE(numout,*) '    Starting indices'
+            WRITE(numout,*) '        ', (ntsj_a(jt), jt=1, nijtile, iitile)
+            WRITE(numout,*) '    Ending indices'
+            WRITE(numout,*) '        ', (ntej_a(jt), jt=1, nijtile, iitile)
+         ELSE
+            WRITE(numout,*) 'No domain tiling'
+            WRITE(numout,*) '    i indices =', ntsi, ':', ntei
+            WRITE(numout,*) '    j indices =', ntsj, ':', ntej
+         ENDIF
+      ENDIF
+   END SUBROUTINE dom_tile_init
+
+
+   SUBROUTINE dom_tile( ktsi, ktsj, ktei, ktej, ktile, ldhold, cstr )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE dom_tile  ***
       !!
-      !! ** Purpose :   Set tile domain variables
+      !! ** Purpose :   Set the current tile and its domain indices
       !!
       !! ** Action  : - ktsi, ktsj     : start of internal part of domain
       !!              - ktei, ktej     : end of internal part of domain
-      !!              - ntile          : current tile number
-      !!              - nijtile        : total number of tiles
+      !!              - nthl, nthr     : modifier on DO loop macro bound offset (left, right)
+      !!              - nthb, ntht     :              "         "               (bottom, top)
+      !!              - ktile          : set the current tile number (ntile)
       !!----------------------------------------------------------------------
       INTEGER, INTENT(out) :: ktsi, ktsj, ktei, ktej      ! Tile domain indices
-      INTEGER, INTENT(in), OPTIONAL :: ktile              ! Tile number
-      INTEGER ::   jt                                     ! dummy loop argument
-      INTEGER ::   iitile, ijtile                         ! Local integers
-      CHARACTER (len=11) ::   charout
-      !!----------------------------------------------------------------------
-      IF( PRESENT(ktile) .AND. ln_tile ) THEN
-         ntile = ktile                 ! Set domain indices for tile
-         ktsi = ntsi_a(ktile)
-         ktsj = ntsj_a(ktile)
-         ktei = ntei_a(ktile)
-         ktej = ntej_a(ktile)
-
+      INTEGER, INTENT(in)  :: ktile                       ! Tile number
+      LOGICAL, INTENT(in), OPTIONAL :: ldhold             ! Pause/resume (.true.) or set (.false.) current tile
+      CHARACTER(len=*), INTENT(in), OPTIONAL   :: cstr    ! Debug information (added to warnings)
+      CHARACTER(len=23) :: clstr
+      LOGICAL :: llhold
+      CHARACTER(len=11)   :: charout
+      INTEGER :: iitile
+      !!----------------------------------------------------------------------
+      llhold = .FALSE.
+      IF( PRESENT(ldhold) ) llhold = ldhold
+      clstr = ''
+      IF( PRESENT(cstr) ) clstr = TRIM(' ('//TRIM(cstr)//')')
+
+      IF( .NOT. ln_tile ) CALL ctl_stop('Cannot use dom_tile with ln_tile = .false.')
+      IF( .NOT. llhold ) THEN
+         IF( .NOT. l_istiled ) THEN
+            CALL ctl_warn('Cannot call dom_tile when tiling is inactive'//clstr)
+            RETURN
+         ENDIF
+
+         IF( ntile /= 0 ) l_tilefin(ntile) = .TRUE.         ! If setting a new tile, the current tile is complete
+
+         ntile = ktile                                      ! Set the new tile
          IF(sn_cfctl%l_prtctl) THEN
-            WRITE(charout, FMT="('ntile =', I4)") ktile
+            WRITE(charout, FMT="('ntile =', I4)") ntile
             CALL prt_ctl_info( charout )
          ENDIF
-      ELSE
-         ntile = 0                     ! Initialise to full domain
-         nijtile = 1
-         ktsi = Nis0
-         ktsj = Njs0
-         ktei = Nie0
-         ktej = Nje0
-
-         IF( ln_tile ) THEN            ! Calculate tile domain indices
-            iitile = Ni_0 / nn_ltile_i       ! Number of tiles
-            ijtile = Nj_0 / nn_ltile_j
-            IF( MOD( Ni_0, nn_ltile_i ) /= 0 ) iitile = iitile + 1
-            IF( MOD( Nj_0, nn_ltile_j ) /= 0 ) ijtile = ijtile + 1
-
-            nijtile = iitile * ijtile
-            ALLOCATE( ntsi_a(0:nijtile), ntsj_a(0:nijtile), ntei_a(0:nijtile), ntej_a(0:nijtile) )
-
-            ntsi_a(0) = ktsi                 ! Full domain
-            ntsj_a(0) = ktsj
-            ntei_a(0) = ktei
-            ntej_a(0) = ktej
-
-            DO jt = 1, nijtile               ! Tile domains
-               ntsi_a(jt) = Nis0 + nn_ltile_i * MOD(jt - 1, iitile)
-               ntsj_a(jt) = Njs0 + nn_ltile_j * ((jt - 1) / iitile)
-               ntei_a(jt) = MIN(ntsi_a(jt) + nn_ltile_i - 1, Nie0)
-               ntej_a(jt) = MIN(ntsj_a(jt) + nn_ltile_j - 1, Nje0)
-            ENDDO
-         ENDIF
-
-         IF(lwp) THEN                  ! control print
-            WRITE(numout,*)
-            WRITE(numout,*) 'dom_tile : Domain tiling decomposition'
-            WRITE(numout,*) '~~~~~~~~'
-            IF( ln_tile ) THEN
-               WRITE(numout,*) iitile, 'tiles in i'
-               WRITE(numout,*) '    Starting indices'
-               WRITE(numout,*) '        ', (ntsi_a(jt), jt=1, iitile)
-               WRITE(numout,*) '    Ending indices'
-               WRITE(numout,*) '        ', (ntei_a(jt), jt=1, iitile)
-               WRITE(numout,*) ijtile, 'tiles in j'
-               WRITE(numout,*) '    Starting indices'
-               WRITE(numout,*) '        ', (ntsj_a(jt), jt=1, nijtile, iitile)
-               WRITE(numout,*) '    Ending indices'
-               WRITE(numout,*) '        ', (ntej_a(jt), jt=1, nijtile, iitile)
-            ELSE
-               WRITE(numout,*) 'No domain tiling'
-               WRITE(numout,*) '    i indices =', ktsi, ':', ktei
-               WRITE(numout,*) '    j indices =', ktsj, ':', ktej
-            ENDIF
-         ENDIF
-      ENDIF
+      ENDIF
+
+      ktsi = ntsi_a(ktile)                                  ! Set the domain indices
+      ktsj = ntsj_a(ktile)
+      ktei = ntei_a(ktile)
+      ktej = ntej_a(ktile)
+
+      ! Calculate the modifying factor on DO loop bounds (1 = do not work on points that have already been processed by a neighbouring tile)
+      nthl = 0 ; nthr = 0 ; nthb = 0 ; ntht = 0
+      iitile = Ni_0 / nn_ltile_i
+      IF( MOD( Ni_0, nn_ltile_i ) /= 0 ) iitile = iitile + 1
+      IF( ktsi > Nis0 ) THEN ; IF( l_tilefin(ktile - 1     ) ) nthl = 1 ; ENDIF    ! Left adjacent tile
+      IF( ktei < Nie0 ) THEN ; IF( l_tilefin(ktile + 1     ) ) nthr = 1 ; ENDIF    ! Right  "  "
+      IF( ktsj > Njs0 ) THEN ; IF( l_tilefin(ktile - iitile) ) nthb = 1 ; ENDIF    ! Bottom "  "
+      IF( ktej < Nje0 ) THEN ; IF( l_tilefin(ktile + iitile) ) ntht = 1 ; ENDIF    ! Top    "  "
    END SUBROUTINE dom_tile
 
+
+   SUBROUTINE dom_tile_start( ldhold, cstr )
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE dom_tile_start  ***
+      !!
+      !! ** Purpose : Start or resume the use of tiling
+      !!
+      !! ** Method  : dom_tile_start & dom_tile_stop are used to declare a tiled region of code.
+      !!
+      !!              Tiling is active/inactive (l_istiled = .true./.false.) within/outside of this code region.
+      !!              After enabling tiling, no tile will initially be set (the full domain will be used) and dom_tile must
+      !!              be called to set a specific tile to work on. Furthermore, all tiles will be marked as incomplete
+      !!              (ln_tilefin(:) = .false.).
+      !!
+      !!              Tiling can be paused/resumed within the tiled code region by calling dom_tile_stop/dom_tile_start
+      !!              with ldhold = .true.. This can be used to temporarily revert back to using the full domain.
+      !!
+      !!                 CALL dom_tile_start                                  ! Enable tiling
+      !!                    CALL dom_tile(ntsi, ntei, ntsj, ntej, ktile=n)    ! Set current tile "n"
+      !!                    ...
+      !!                    CALL dom_tile_stop(.TRUE.)                        ! Pause tiling (temporarily disable)
+      !!                    ...
+      !!                    CALL dom_tile_start(.TRUE.)                       ! Resume tiling
+      !!                 CALL dom_tile_stop                                   ! Disable tiling
+      !!----------------------------------------------------------------------
+      LOGICAL, INTENT(in), OPTIONAL :: ldhold            ! Resume (.true.) or start (.false.)
+      LOGICAL :: llhold
+      CHARACTER(len=*), INTENT(in), OPTIONAL   :: cstr   ! Debug information (added to warnings)
+      CHARACTER(len=23) :: clstr
+      !!----------------------------------------------------------------------
+      llhold = .FALSE.
+      IF( PRESENT(ldhold) ) llhold = ldhold
+      clstr = ''
+      IF( PRESENT(cstr) ) clstr = TRIM(' ('//TRIM(cstr)//')')
+
+      IF( .NOT. ln_tile ) CALL ctl_stop('Cannot resume/start tiling as ln_tile = .false.')
+      IF( l_istiled ) THEN
+         CALL ctl_warn('Cannot resume/start tiling as it is already active'//clstr)
+         RETURN
+      ! TODO: [tiling] this warning will always be raised outside a tiling loop (cannot check for pause rather than stop)
+      ELSE IF( llhold .AND. ntile == 0 ) THEN
+         CALL ctl_warn('Cannot resume tiling as it is not paused'//clstr)
+         RETURN
+      ENDIF
+
+      ! Whether resumed or started, the tiling is made active. If resumed, the domain indices for the current tile are used.
+      IF( llhold ) CALL dom_tile(ntsi, ntsj, ntei, ntej, ktile=ntile, ldhold=.TRUE., cstr='dom_tile_start'//clstr)
+      l_istiled = .TRUE.
+   END SUBROUTINE dom_tile_start
+
+
+   SUBROUTINE dom_tile_stop( ldhold, cstr )
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE dom_tile_stop  ***
+      !!
+      !! ** Purpose : End or pause the use of tiling
+      !!
+      !! ** Method  : See dom_tile_start
+      !!----------------------------------------------------------------------
+      LOGICAL, INTENT(in), OPTIONAL :: ldhold            ! Pause (.true.) or stop (.false.)
+      LOGICAL :: llhold
+      CHARACTER(len=*), INTENT(in), OPTIONAL   :: cstr   ! Debug information (added to warnings)
+      CHARACTER(len=23) :: clstr
+      !!----------------------------------------------------------------------
+      llhold = .FALSE.
+      IF( PRESENT(ldhold) ) llhold = ldhold
+      clstr = ''
+      IF( PRESENT(cstr) ) clstr = TRIM(' ('//TRIM(cstr)//')')
+
+      IF( .NOT. ln_tile ) CALL ctl_stop('Cannot pause/stop tiling as ln_tile = .false.')
+      IF( .NOT. l_istiled ) THEN
+         CALL ctl_warn('Cannot pause/stop tiling as it is inactive'//clstr)
+         RETURN
+      ENDIF
+
+      ! Whether paused or stopped, the tiling is made inactive and the full domain indices are used.
+      ! If stopped, there is no active tile (ntile = 0) and the finished tile indicators are reset
+      CALL dom_tile(ntsi, ntsj, ntei, ntej, ktile=0, ldhold=llhold, cstr='dom_tile_stop'//clstr)
+      IF( .NOT. llhold ) l_tilefin(:) = .FALSE.
+      l_istiled = .FALSE.
+   END SUBROUTINE dom_tile_stop
    !!======================================================================
 END MODULE domtile
